import 'dart:html';

import 'package:angular/angular.dart';

@Directive(selector: '[swipy]')
class Swipy {
  var start_x = 0;
  var start_y = 0;
  var end_x = 0;
  var end_y = 0;
  @Input()
  dynamic swipeLeft, swipeRight, swipeUp, swipeDown;
  final Element _el;
  Swipy(this._el) {
    _el.addEventListener('touchstart', (event) {
      var a = (event as TouchEvent);
      a.preventDefault();
      start_x = a.changedTouches[0].page.x;
      start_y = a.changedTouches[0].page.y;
    });
    _el.addEventListener('touchend', (event) {
      var a = (event as TouchEvent);
      end_x = a.changedTouches[0].page.x;
      end_y = a.changedTouches[0].page.y;
      if ((end_x - start_x) <= -30 && (end_y - start_y) <= 100) {
        swipeLeft();
      } else if ((end_x - start_x) >= 30 && (end_y - start_y) <= 100) {
        swipeRight();
      } else if ((end_x - start_x) <= 100 && (end_y - start_y) <= 30) {
        swipeUp();
      } else if ((end_x - start_x) <= 100 && (end_y - start_y) >= -30) {
        swipeDown();
      }
    });
  }
}

@Directive(selector: '[touchy]')
class Touchy {
  @Input()
  dynamic softtouchy, hardtouchy, startTime, endTime;

  final Element _el;
  Touchy(this._el) {
    _el.addEventListener('touchstart', (event) {
      event.preventDefault();
      event
          .stopPropagation(); // not necessary in my case, could leave in case stopImmediateProp isn't available?
      event.stopImmediatePropagation();
      startTime = DateTime.now();
      print(startTime);
    });
    _el.addEventListener('touchend', (event) {
      event.preventDefault();
      event
          .stopPropagation(); // not necessary in my case, could leave in case stopImmediateProp isn't available?
      event.stopImmediatePropagation();
      endTime = DateTime.now();
      print(endTime);
      print(startTime.difference(endTime).inMicroseconds);
      print(startTime.difference(endTime).inMilliseconds);
      if (startTime.difference(endTime).inSeconds >= 3) {
        hardtouchy();
      } else if (startTime.difference(endTime).inSeconds <= 2 &&
          startTime.difference(endTime).inSeconds > 0) {
        softtouchy();
      }
    });
  }
}
